# Migration features

:white_check_mark: = supported

:heavy_minus_sign: = not yet supported / in development

:x: = not supported

`NK` = “Not Known”

NOTE: Features not listed in the matrix should be presumed to be not yet supported.

| Main | Feature | Sub-feature | GitLab export/import | Direct Transfer | Congregate | Introduced (Export/Import) | Introduced (Direct Transfer) | Min. Tier | Min. Permission |
|----|----|----|----|----|----|----|----|----|----|
| **Group** |    |    |    |    |    |    |    |    |    |
|    | Milestones |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 9.5 | 13.10 | Core/Free | `N/A` |
|    | Badges |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 10.6 | 13.7 | Core/Free | `N/A` |
|    | Labels |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 11.8 | 13.9 | Core/Free (Scoped - Premium/Silver) | `N/A` |
|    | Boards | Board Assignee, Labels, Lists | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 13.7 | Core/Free (Multiple Group - Premium/Silver) | `N/A` |
|    | Members |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 13.9 | Core/Free | `N/A` |
|    | Epics | Parent, Award Emoji, Events, Notes, Discussions | :white_check_mark: | :white_check_mark: | :white_check_mark: | 10.2 | 13.7 | Premium/Silver (Multi-level - Ultimate/Gold) | `N/A` |
|    | Wikis |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | Introduced in 13.5. File-based export support since 13.9 |    | Premium/Silver | Owner |
|    | CI/CD variables |    | :x: | :x: | :white_check_mark: | 9.4 |    | Core/Free | Owner |
|    | Hooks |    | :x: | :x: | :white_check_mark: | 12.8 |    | Premium | Owner |
|    | Clusters |    | :x: | :x: | :white_check_mark: | 11.6 (Deprecated as of 14.5) |    | Core/Free | Owner |
|    | Shared Groups |    | :x: | :white_check_mark: | :white_check_mark: (with direct transfer enabled) | 12.7 | `NK` | Core/Free | Owner |
|    | Notification settings |    | :x: | :x: | :heavy_minus_sign: | 8.12 |    | Core/Free | Owner |
|    | Push Rules |    | :x: | :x: | :heavy_minus_sign: | 13.4 |    | Premium | Owner |
|    | Deploy Tokens |    | :x: | :x: | :x: | 12.9 |    | Core/Free | Owner |
|    | Audit Events |    | :x: | :x: | :x: | 12.5 |    | Premium/Silver | Owner |
|    | Avatars |    | :x: | :x: | :x: | 12.9 |    | Core/Free | `N/A` |
|    | Runners |    | :x: | :x: | :x: | 8.5 |    | Core/Free | Owner |
|    | File Templates |    | :x: | :x: | :x: | 11.6 |    | Premium/Silver | Owner |
| **Project** |    |    |    |    |    |    |    |    |    |
|    | Labels |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.4 | Core/Free (Scoped - Premium/Silver) | `N/A` |
|    | Milestones | Events | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.5 | Core/Free | `N/A` |
|    | Issues | Events, Timelogs, Notes, Label Links, Milestone, Resource Label Events, Issue Assignees, Zoom Meetings, Sentry Issue, Award Emoji, Designs, Design Versions, Epic, Discussions | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.4 | Core/Free | `N/A` |
|    | Snippets | Notes, Award Emoji, Discussions | :white_check_mark: | :white_check_mark: | :white_check_mark: | 8.15 | 14.6 | Core/Free | `N/A` |
|    | Releases |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 11.7 | 15.1 | Core/Free | `N/A` |
|    | Members |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.8 | Core/Free | `N/A` |
|    | Merge requests | Metrics, Award Emoji, Notes, Merge Request Diff, Events, Timelogs, Label Links, Milestone, Resource Label Events, Discussions | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.5 | Core/Free | `N/A` |
|    | CI Pipelines | Notes, Stages, External Pull Requests, Merge Request, Discussions | :white_check_mark: | :white_check_mark: | :white_check_mark: | 8.8 | 14.6 | Core/Free | `N/A` |
|    | Pipeline schedules |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 9.1 | 14.8 | Core/Free | `N/A` |
|    | External Pull Requests |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 12.3 | 14.5 | Premium/Silver | `N/A` |
|    | Auto DevOps |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 10.0 | 14.6 | Core/Free | `N/A` |
|    | Protected Branches | Merge Access Levels, Push Access Levels, Unprotect Access Levels | :white_check_mark: | :white_check_mark: | :white_check_mark: | 8.11 | 14.7 | Core/Free | `N/A` |
|    | Branches |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.7 | Core/Free | `N/A` |
|    | Commits | NOT Discussions | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | `NK` | Core/Free | `N/A` |
|    | Default Branch |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | `NK` | Core/Free | `N/A` |
|    | Protected Environments | Deploy Access Levels | :x: | :x: | :white_check_mark: | 11.3 | `NK` | Premium/Silver | `N/A` |
|    | Protected Tags | Create Access Levels | :white_check_mark: | :white_check_mark: | :white_check_mark: | 9.1 | `NK` | Core/Free | `N/A` |
|    | Features |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.6 | Core/Free | `N/A` |
|    | Custom Attributes |    | :white_check_mark: |    | :white_check_mark: | `NK` |    | Core/Free | `N/A` |
|    | Badges |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 10.7 | 14.6 | Core/Free | `N/A` |
|    | CI/CD Settings |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.6 | Core/Free | `N/A` |
|    | Error Tracking Settings |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 11.8 | `NK` | Core/Free | Maintainer |
|    | Metrics Settings |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | `NK` | Core/Free | `N/A` |
|    | Issue Boards | Lists | :white_check_mark: | :white_check_mark: | :white_check_mark: | 8.11 | 14.4 | Core/Free | `N/A` |
|    | Service Desk Setting |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 9.1 | `NK` | Core/Free | `N/A` |
|    | Avatars |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 11.0 | 14.6 | Core/Free | `N/A` |
|    | Uploads |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | `NK` | 14.5 | Core/Free | `N/A` |
|    | LFS Objects |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 8.2 | 14.8 | Core/Free | `N/A` |
|    | Wikis |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 10.0 | 14.6 | Core/Free | `N/A` |
|    | Container Expiration Policy |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 12.8 | 14.6 | Core/Free | `N/A` |
|    | Awards |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 8.9 | `NK` | Core/Free | `N/A` |
|    | Description Templates (issue, MR) |    | :white_check_mark: | :white_check_mark: | :white_check_mark: | 13.3 | `NK` | Core/Free | `N/A` |
|    | Push rules |    | ✅ (as of 13.6) | :white_check_mark: | :white_check_mark: | `NK` | 14.6 | Premium | Maintainer |
|    | CI/CD variables |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Maintainer |
|    | Merge request approvals |    | :x: | :white_check_mark: | :white_check_mark: | 7.2 | 15.3 | Core/Free (Required - Premium) | Maintainer |
|    | Shared Groups |    | :x: | :white_check_mark: | :white_check_mark: | `NK` | `NK` | Core/Free | Maintainer |
|    | Container Registry |    | :x: | :x: | :white_check_mark: | 8.8 |    | Core/Free | Maintainer |
|    | Package Registry | Maven, PyPI, NPM, Generic | :x: | :x: | :white_check_mark: | 11.3 |    | Core/Free | Maintainer |
|    | Deploy keys |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Maintainer |
|    | Webhooks (w/o tokens) |    | :x: | :x: | :white_check_mark: | 8.5 |    | Core/Free | Maintainer |
|    | Environments |    | :x: | :x: | :white_check_mark: | 8.9 |    | Core/Free (Protected - Premium/Silver) | Maintainer |
|    | Pipeline schedule variables |    | :x: | :x: | :white_check_mark: | 9.4 |    | Core/Free | Maintainer |
|    | Clusters |    | :x: | :x: | :white_check_mark: | 10.1 (Deprecated as of 14.5) |    | Core/Free | Maintainer |
|    | Fork relationship |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Owner |
|    | Agents |    | :x: | :x: | :heavy_minus_sign: | 14.10 |    | Core/Free | Maintainer |
|    | Remote mirrors |    | :x: | :x: | :heavy_minus_sign: | 8.2 |    | Core/Free (Pull - Premium) | Maintainer |
|    | Feature Flags |    | :x: | :x: | :heavy_minus_sign: | 11.4 |    | Core/Free | Developer |
|    | Notification settings |    | :x: | :x: | :heavy_minus_sign: | 8.12 |    | Core/Free | Maintainer |
|    | Pages domains |    | :x: | :x: | :heavy_minus_sign: | 8.3 |    | Core/Free | Maintainer |
|    | Managed Licenses |    | :x: | :x: | :heavy_minus_sign: | 11.0 (Deprecated as of 15.9) |    | Ultimate/Gold | Maintainer |
|    | Pipeline Triggers |    | :x: | :x: | :x: | `NK` |    | Core/Free | `N/A` |
|    | Pipeline Tokens |    | :x: | :x: | :x: | `NK` |    | Core/Free | `N/A` |
|    | Infrastructure Registry | Terraform | :x: | :x: | :x: | 14.0 |    | Core/Free | Maintainer |
|    | Deploy tokens |    | :x: | :x: | :x: | 10.7 |    | Core/Free | Maintainer |
|    | Build Artifacts |    | :x: | :x: | :x: | 8.2 |    | Core/Free | Maintainer |
|    | Audit Events |    | :x: | :x: | :x: | `NK` |    | Premium/Silver | Maintainer |
|    | Services/Integrations |    | :x: | :x: | :x: | `NK` |    | Core/Free | Maintainer |
|    | Runners |    | :x: | :x: | :x: | 13.2 |    | Core/Free | Maintainer |
|    | Templates (built-in and custom) |    | :x: | :x: | :x: | 11.2 |    | Premium/Silver | Maintainer |
|    | Topics |    | :x: | :x: | :x: | `NK` |    | Core/Free | Maintainer |
|    | Activity |    | :x: | :x: | :x: | `NK` |    | Core/Free | Maintainer |
| **User** |    |    |    |    |    |    |    |    |    |
|    | Account |    | :x: | :x: | :white_check_mark: | `NA` |    | Core/Free | Admin |
|    | Avatars |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Admin |
|    | Profile (API) |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Admin |
|    | Preferences (API) |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Admin |
|    | Runner minutes limit | shared and extra | :x: | :x: | :white_check_mark: | `NK` |    | Premium | Admin |
|    | Group SAML |    | :x: | :x: | :white_check_mark: | `NK` |    | Premium/Silver | Admin |
|    | SSH keys |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Admin |
|    | GPG keys |    | :x: | :x: | :white_check_mark: | 9.5 |    | Core/Free | Admin |
|    | Secondary emails |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core/Free | Admin |
|    | Account settings |    | :x: | :x: | :x: | `NK` |    | Core/Free | `N/A` |
|    | Applications |    | :x: | :x: | :x: | `NK` |    | Core/Free | `N/A` |
|    | Access Tokens |    | :x: | :x: | :x: | 8.8 |    | Core/Free | `N/A` |
|    | Impersonation Tokens |    | :x: | :x: | :x: | `NK` |    | Core/Free | Admin |
|    | Active Sessions |    | :x: | :x: | :x: | 10.8 |    | Core/Free | `N/A` |
| **Standalone (instance)** |    |    |    |    |    |    |    |    |    |
|    | System hooks (w/o tokens) |    | :x: | :x: | :white_check_mark: | `NK` |    | Core/Free | Admin |
|    | Clusters |    | :x: | :x: | :white_check_mark: | 11.11 (Deprecated as of 14.5) |    | Core/Free | Admin |
|    | Features (Feature flags) |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core/Free | Admin |
|    | CI/CD variables |    | :x: | :x: | :heavy_minus_sign: | 13.0 |    | Core | Admin |
|    | Applications |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core/Free | Admin |
|    | Settings |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core | Admin |
|    | Appearance |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core | Admin |
|    | Broadcast Messages |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core/Free | Admin |
|    | Notification settings |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core/Free | Admin |
|    | Runners |    | :x: | :x: | :heavy_minus_sign: | `NK` |    | Core/Free | Admin |
|    | Code snippets |    | :x: | :x: | :heavy_minus_sign: | 8.15 |    | Core/Free | Admin |
|    | Project Topics |    | :x: | :x: | :heavy_minus_sign: | 14.5 |    | Core/Free | Admin |
|    | Pages domains |    | :x: | :x: | :x: | 8.3 |    | Core/Free | Admin |
|    | Deploy keys |    | :x: | :x: | :x: | `NK` |    | Core | Admin |
|    | Deploy tokens |    | :x: | :x: | :x: | `NK` |    | Core | Admin |
|    | ToDos |    | :x: | :x: | :x: | 8.5 |    | Core/Free | Guest |
|    | Audit Events |    | :x: | :x: | :x: | 9.3 |    | Premium/Silver | Admin |
|    | Avatar |    | :x: | :x: | :x: | `NK` |    | Core/Free | Guest |
|    | Personal Access Tokens |    | :x: | :x: | :x: | 8.8 |    | Ultimate | Guest (All - Admin) |
|    | File Templates |    | :x: | :x: | :x: | 11.3 |    | Premium | Guest |
|    | Service Templates |    | :x: | :x: | :x: | `NK` |    | Core | `N/A` |
|    |    |    |    |    |    |    |    |    |    |


